// Generated on 2011 July Wed, 20 at 18:05:17 by the CERTI message generator
// ----------------------------------------------------------------------------
// CERTI - HLA Run Time Infrastructure
// Copyright (C) 2010 Andrej Pancik
//
// This program is free software ; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation ; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY ; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program ; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
// ----------------------------------------------------------------------------
package certi;

import certi.communication.CertiException;
import certi.communication.MessageBuffer;
import certi.communication.CertiMessageType;
import certi.communication.CertiMessage;
import certi.rti.impl.CertiAttributeHandleSet;
import certi.rti.impl.CertiSuppliedAttributes;
import hla.rti.AttributeHandleSet;
import hla.rti.SuppliedAttributes;
import certi.rti.impl.CertiExtent;
import java.util.List;
import hla.rti.Region;
import hla.rti.FederateHandleSet;
import hla.rti.SuppliedParameters;
import certi.rti.impl.CertiLogicalTime;
import certi.rti.impl.CertiLogicalTimeInterval;
import hla.rti.LogicalTime;
import hla.rti.LogicalTimeInterval;

public class GetOrderingHandle extends CertiMessage {
   private String orderingName;
   private OrderType ordering=0;

   public GetOrderingHandle() {
      super(CertiMessageType.GET_ORDERING_HANDLE);
   }

   public GetOrderingHandle(CertiLogicalTime federationTime) {
      super(CertiMessageType.GET_ORDERING_HANDLE, federationTime);
   }

   @Override
   public void writeMessage(MessageBuffer messageBuffer) {
      super.writeMessage(messageBuffer); //Header

      messageBuffer.write(orderingName);
      messageBuffer.write(ordering);
   }

   @Override
   public void readMessage(MessageBuffer messageBuffer) throws CertiException {
      super.readMessage(messageBuffer); //Header 

      messageBuffer.write(orderingName);
      messageBuffer.write(ordering);
   }

   @Override
   public String toString() {
      return (super.toString() + ", orderingName: " + orderingName + ", ordering: " + ordering);
   }

   public String getOrderingName() {
      return orderingName;
   }

   public OrderType getOrdering() {
      return ordering;
   }

   public void setOrderingName(String newOrderingName) {
      this.orderingName = newOrderingName;
   }

   public void setOrdering(OrderType newOrdering) {
      this.ordering = newOrdering;
   }

}

